/* This file containd the code which adds to the IOC shell two functions: addGPMMRegister and GPMMConfigure */
/* Code created by M.Dach 02.2008 */

#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include  <epicsExport.h>
#include "iocsh.h"
#include "drvGPMM.h"
#include <dlfcn.h>

static void *handleUserFunctionfile=NULL;
/* Declare user defined functions which could be stored in the dynamicly loaded library */
/* 
extern  int userGPMMFunc1  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc2  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc3  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc4  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc5  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc6  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc7  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc8  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc9  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
extern  int userGPMMFunc10 ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);


struct userGPMMFuncStruct
     {
       char const *fname;
       int  (*fnct)(unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);
     };
     
     struct userGPMMFuncStruct const user_fncts[] =
     {
       {"debugGPMMFunc", debugGPMMFunc},
       {"debug2GPMMFunc",debug2GPMMFunc},
       {"userGPMMFunc1",  userGPMMFunc1},
       {"userGPMMFunc2",  userGPMMFunc2},
       {"userGPMMFunc3",  userGPMMFunc3},
       {"userGPMMFunc4",  userGPMMFunc4},
       {"userGPMMFunc5",  userGPMMFunc5},
       {"userGPMMFunc6",  userGPMMFunc6},
       {"userGPMMFunc7",  userGPMMFunc7},
       {"userGPMMFunc8",  userGPMMFunc8},
       {"userGPMMFunc9",  userGPMMFunc9},
       {"userGPMMFunc10",  userGPMMFunc10}, 
       {0, 0}
     };
    
*/ 
/* this function returns the pointer to the given function */
/*    
int * getUserFuncGPMMF (char *sFuncName)
     {
       int i;
     
       for (i = 0; user_fncts[i].fname != 0; i++)
         {
	   if(strstr(user_fncts[i].fname,sFuncName)){
	     return((int *)(user_fncts[i].fnct));
	   }
         }
	   return((int *)NULL);
     }

*/

/* Example code to see the possibility to add additional function calls to the iocsh */
/* Mirek ins EPICS input output controller  p.245*/

/* let say that we want to have a function in iocSh gpmmPrint(int, *char ) */

/* define two input args */
static const iocshArg gpmmArg0 = {"Base addr",iocshArgInt};
static const iocshArg gpmmArg1 = {"Card Name",iocshArgString};

/* prepare the Args pointer */
static const iocshArg *const gpmmArgs[2] = { &gpmmArg0,&gpmmArg1};

static const iocshFuncDef gpmmPrintMyFuncDef = {"gpmmPrint",2,gpmmArgs};
/* define the function call */
static void  gpmmPrintMyFuncCall (const iocshArgBuf *args)
{
  printf("Test gpmm function call iVal=0x%04x\tstrVal=%s\n",args[0].ival,args[1].sval);
} 

/****************************************************************************************************/
/* let say that we want to have a function  loadGPMMUserFunc iocSh (*char ) */
/****************************************************************************************************/

/* define two input args */
static const iocshArg ppcLoadGPMMUserArg0 = {"User Functions file name",iocshArgString};

/****************************/
/* prepare the Args pointer */
/****************************/

static const iocshArg *const ppcLoadGPMMUserArgs[1] = { &ppcLoadGPMMUserArg0};
static const iocshFuncDef ppcLoadGPMMUserFuncDef    = {"loadGPMMUserFunc",1,ppcLoadGPMMUserArgs};

/****************************************************************************************************/
/* define the function call */
/****************************************************************************************************/

static void  ppcLoadGPMMUserFuncCall (const iocshArgBuf *args)
{
   char strBuff[50]="";
   
   printf("Loading user functions  %s\n",args[0].sval);

   sprintf(strBuff,"lib%s.so",args[0].sval);

   handleUserFunctionfile = dlopen (strBuff, RTLD_LAZY);
   if (!handleUserFunctionfile) {
     fprintf (stderr, "%s\n", dlerror());
     return;
   }

   return ;
} 


/*--------------------------------------------------------------------*/
/* Incoroprate to the iocshell the addGPMMInterrupt configure function */
/*--------------------------------------------------------------------*/

static const iocshArg gpmmIntrArg0 = {"Not used - set 0: Mem region Nr",iocshArgInt};
static const iocshArg gpmmIntrArg1 = {"Interrupt Nr",iocshArgInt};
static const iocshArg gpmmIntrArg2 = {"Intr register Base Addr",iocshArgInt};
static const iocshArg gpmmIntrArg3 = {"Not used - set NULL: User def ISR",iocshArgString};


/* prepare the Args pointer */

static const iocshArg *const gpmmIntrArgs[4] = { &gpmmIntrArg0,&gpmmIntrArg1,&gpmmIntrArg2,&gpmmIntrArg3};

static const iocshFuncDef gpmmIntrDef = {"addGPMMInterrupt",4,gpmmIntrArgs};
/*------------------------------------------------------------------*/
/*             define the function call                             */
/*------------------------------------------------------------------*/
static void  myaddGPMMInterruptFuncCall (const iocshArgBuf *args)
{
  char *error;
  char strBuff[50]="";
   
   void (*gpmmUserISR)   (struct io_GPMM *pPrivate);

   gpmmUserISR=NULL;
   if(strcmp(args[3].sval,"NULL")){
     if(handleUserFunctionfile){
       sprintf(strBuff,"%s",args[3].sval);
       gpmmUserISR = dlsym(handleUserFunctionfile,strBuff );
       if ((error = dlerror()) != NULL)  {
	 fprintf (stderr, "%s\n", error);
	 gpmmUserISR=NULL;
       } 
     }/* if handleUserFunctionfile */
   }/* if NULL */


    addGPMMInterrupt(args[0].ival,args[1].ival,args[2].ival,gpmmUserISR);
    
  
} 


/*--------------------------------------------------------------------*/
/* Incoroprate to the iocshell the addGPMMRegister configure function */
/*--------------------------------------------------------------------*/

static const iocshArg gpmmRegisterArg0 = {"Mem region Nr",iocshArgInt};
static const iocshArg gpmmRegisterArg1 = {"Ref number",iocshArgInt};
static const iocshArg gpmmRegisterArg2 = {"Addr Offset",iocshArgInt};
static const iocshArg gpmmRegisterArg3 = {"Size of the Mem region",iocshArgInt};
static const iocshArg gpmmRegisterArg4 = {"Read/Write flag",iocshArgString};
static const iocshArg gpmmRegisterArg5 = {"Reg desc max 20 Char",iocshArgString};
static const iocshArg gpmmRegisterArg6 = {"User function Ignore",iocshArgString};

/* prepare the Args pointer */

static const iocshArg *const gpmmRegisterArgs[7] = { &gpmmRegisterArg0,&gpmmRegisterArg1,&gpmmRegisterArg2,&gpmmRegisterArg3,&gpmmRegisterArg4,&gpmmRegisterArg5,&gpmmRegisterArg6};

static const iocshFuncDef gpmmRegisterDef = {"addGPMMRegister",7,gpmmRegisterArgs};
/*------------------------------------------------------------------*/
/*             define the function call                             */
/*------------------------------------------------------------------*/
static void  myaddGPMMRegisterFuncCall (const iocshArgBuf *args)
{
  char *error;
  char strBuff[50]="";
   int (*userGPMMFunc1)  ( unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void *);

  /*  printf("My new funstion: Card nr %d iRef %d AddresOffset %d Bytes Nr %d Flag %c Desc %s\n",args[0].ival,args[1].ival,args[2].ival,args[3].ival,(char) args[4].sval[0],args[5].sval); */

   userGPMMFunc1=NULL;
   if(strcmp(args[6].sval,"NULL")){
     if(handleUserFunctionfile){
       sprintf(strBuff,"%s",args[6].sval);
       userGPMMFunc1 = dlsym(handleUserFunctionfile,strBuff );
       if ((error = dlerror()) != NULL)  {
	 fprintf (stderr, "%s\n", error);
	 userGPMMFunc1=NULL;
       } 
     }/* if handleUserFunctionfile */
   }/* if NULL */


    addGPMMRegister(args[0].ival,args[1].ival,args[2].ival,args[3].ival,(char) args[4].sval[0],args[5].sval,userGPMMFunc1);
    /* (int (*)(unsigned short, unsigned short, struct recDesc *, unsigned short, unsigned short, char *, void * ))getUserFuncGPMMF(args[6].sval)); */
  
} 

/*------------------------------------------------------------------*/
/* Incoroprate to the iocshell the GPMMConfigure configure function */
/*------------------------------------------------------------------*/

static const iocshArg gpmmConfigureArg0 = {"Mem region Nr",iocshArgInt};
static const iocshArg gpmmConfigureArg1 = {"Base Addr",iocshArgInt};
static const iocshArg gpmmConfigureArg2 = {"Mem region Name",iocshArgString};
static const iocshArg gpmmConfigureArg3 = {"Addr access mode",iocshArgString};
static const iocshArg gpmmConfigureArg4 = {"Data access mode",iocshArgString};


/* prepare the Args pointer */
static const iocshArg *const gpmmConfigureArgs[5] = { &gpmmConfigureArg0,&gpmmConfigureArg1,&gpmmConfigureArg2,&gpmmConfigureArg3,&gpmmConfigureArg4};

static const iocshFuncDef gpmmConfigureDef = {"GPMMConfigure",5,gpmmConfigureArgs};
/* define the function call */
static void  myGPMMConfigureFuncCall (const iocshArgBuf *args)
{
  /* printf("My new funstion: Card nr %d base address %p Mem region Name %s Addrr mode %s Data mode %s\n",args[0].ival,(void *)args[1].ival,args[2].sval,args[3].sval, args[4].sval); */
  GPMMConfigure(args[0].ival,(void *)args[1].ival,args[2].sval,args[3].sval, args[4].sval);

} 

/* end of the additional commans in the iocsh */

void gpmmPrintMy(){printf("This is only a test\n");}

void epicsFuncGPMMRegister(void){
  iocshRegister(&gpmmPrintMyFuncDef,gpmmPrintMyFuncCall);
  iocshRegister(&gpmmIntrDef,myaddGPMMInterruptFuncCall);
  iocshRegister(&gpmmRegisterDef,myaddGPMMRegisterFuncCall);
  iocshRegister(&gpmmConfigureDef,myGPMMConfigureFuncCall);
  iocshRegister(&ppcLoadGPMMUserFuncDef,ppcLoadGPMMUserFuncCall);
}

/* Register GPMM functions in EPICS env */
epicsExportRegistrar(epicsFuncGPMMRegister);
