/*start of CVS identification*/
/*$Author: zimoch $*/
/*$Date: 2006/12/21 14:35:56 $*/
/*$Id: slsDevLib.h,v 1.4 2006/12/21 14:35:56 zimoch Exp $*/
/*$Name:  $*/
/*$Revision: 1.4 $*/
/*end of CVS identification*/

/*
static char rcsid[] = "$Id: slsDevLib.h,v 1.4 2006/12/21 14:35:56 zimoch Exp $";
*/

/*
 *	KECK Observatory device library include file.
 *
 */

#include <epicsVersion.h>

#define FIRST_USER_VECTOR	64
#define LAST_USER_VECTOR 	255

struct devInfo {
        long                cardNum;
        void                *devAddrs; /* base address of io card */
        long                vectorNum;
        long                itrLevel;
	void		    *devPrivate;
        struct devInfo      *nextCard;
};

#ifdef BASE_VERSION
/* 3.13 */
typedef void * baseaddr_t;
typedef void * localaddr_t;
#else
/* 3.14 */
typedef size_t baseaddr_t;
typedef volatile void * localaddr_t;
#endif
#define slsDevAddrs(NODE) 	((baseaddr_t)((NODE==NULL) ? NULL : NODE->devAddrs))
#define slsDevCardNum(NODE)	((NODE==NULL) ? -1 : NODE->cardNum)
#define slsDevFirst(NODE)	NODE
#define slsDevItrLevel(NODE)	((NODE==NULL) ? -1 : NODE->itrLevel)
#define slsDevNext(NODE)		((NODE==NULL) ? NULL : NODE->nextCard)
#define slsDevPrivate(NODE)	((NODE==NULL) ? NULL : NODE->devPrivate)
#define slsDevVectorNum(NODE)	((NODE==NULL) ? -1 : NODE->vectorNum)

#define slsDevSetVectorNum(NODE,VECTOR) 	 \
	if (NODE != NULL) NODE->vectorNum = VECTOR
#define slsDevSetDevPrivate(NODE,PRIVATE) \
	if (NODE != NULL) NODE->devPrivate = PRIVATE

void slsDevConfigure(
    char	*devName,
    long        cardNum,
    void        *baseAddrs,
    long        vectorNum,
    long        itrLevel,
    void	*devPrivate,
 
    struct devInfo      **pInfoBlock
);

long slsDevInUse(
    void        *baseAddrs,
    long        cardNum,
 
    struct devInfo      **pInfoBlock
);

void slsDevList(
    char            *devType,
    struct devInfo  *pDevList
);

struct devInfo *slsDevNodeByCardNum(
    struct devInfo      *devList,
    long                cardNum
);


long slsDevChgBase(
    struct devInfo	*node,
    void		*baseAddrs
);


/*+*********************************************************************
  $Log: slsDevLib.h,v $
  Revision 1.4  2006/12/21 14:35:56  zimoch
  typedefs for arguments of devRegisterAddress

  Revision 1.3  2006/12/21 14:27:56  zimoch
  fixes for 3.14

  Revision 1.2  1999/08/26 12:20:42  hunt
  *** empty log message ***

  Revision 1.1  1999/08/26 12:18:57  hunt
  *** empty log message ***


  Revision 1.2  1996/05/04 01:49:54  ahoney
  Added prototype for koDevChgBase() - as needed for board checkout mods.

 * Revision 1.1  1996/02/13  21:59:17  ahoney
 * Initial addition for directory koDevLib (related to module_types
 * elimination).
 *
 *
***********************************************************************/
 

