#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define DEBUG
#include <drvGPMM.h>
#include <userGPMM.h>


int userGPMMFunc1(
    unsigned short card,
    unsigned short signal,
    struct recDesc  *parm,
    unsigned short   sRecordType,
    unsigned short   sRecordPass,
    char *chanName,
    void *pVal
    ){

  unsigned long  lVal;
  unsigned short sVal;
  char *pPropertyName;
  short status=RETURN_OK;

  lVal= *((unsigned long  *)pVal);   /* for ai ao record. lVal refers to the rval field */
  sVal= *((unsigned short *)pVal);   /* for mbbi mbbo bi bo */
  
  pPropertyName=strchr(chanName,':');
  
  /*---------------------------------*/
  /* code executed on function enter */
  /*---------------------------------*/
  if(sRecordPass==REC_ENTER){
    /* do the data processing when enetring the driver writ/read function for the specyfic record */
    printf("FUNCTION PASS on ENTER\n");
    printf("IT WORKS\n");

    if(sRecordType==REC_AI){
      printf("Record AI\n");
      printf("Function debugGPMMFunc C%d S%d @%s %s 0x%.8X\n",card,signal,
	     parm->sDesc,chanName,(unsigned int) lVal);
    }
    else if(sRecordType==REC_AO){
      printf("Record AO\n");
      printf("Function debugGPMMFunc C%d S%d @%s %s 0x%.8X\n",card,signal,
	     parm->sDesc,chanName,(unsigned int) lVal);
    }
    else if(sRecordType==REC_MBBI_D){
      printf("Record MBBI DIRECT\n");
      printf("Function debugGPMMFunc C%d S%d @%s %s 0x%.4X\n",card,signal,parm->sDesc,
	     chanName,(unsigned short) sVal);
    }
    else if(sRecordType==REC_MBBO_D){
      printf("Record MBBO DIRECT\n");
      printf("Function debugGPMMFunc C%d S%d @%s %s 0x%.4X\n",card,signal,parm->sDesc,
	     chanName,(unsigned short) sVal);
    }
    else if(sRecordType==REC_BI){
      printf("Record BI \n");
      printf("Function debugGPMMFunc C%d S%d @%s %s 0x%.4X\n",card,signal,parm->sDesc,
	     chanName,(unsigned short) sVal);
    }
    else if(sRecordType==REC_BO){
      printf("Record BO \n");
      printf("Function debugGPMMFunc C%d S%d @%s %s 0x%.4X\n",card,signal,parm->sDesc,
	     chanName,(unsigned short) sVal);
    }


  }
  return (status);
}

/*-----------------------------------------------------------------------------------------*/

int myFirstGPMMFunc(
    unsigned short card,
    unsigned short signal,
    struct recDesc  *parm,
    unsigned short   sRecordType,
    unsigned short   sRecordPass,
    char *chanName,
    void *pVal
    ){

  unsigned long  lVal;
  unsigned short sVal;
  /* char *pPropertyName; */
  short status=RETURN_OK;

  lVal= *((unsigned long  *)pVal);   /* for ai ao record. lVal refers to the rval field */
  sVal= *((unsigned short *)pVal);   /* for mbbi mbbo bi bo */
  
 
PROCESS_DATA_FROM_OUTPUT_RECORD_BEGIN     

/* do your data processing here. Use lVal or sVal depending on your record type */

printf("This is just my Fisrts user function\n");

status =  RETURN_FROM_OUTPUT_RECORD_OK;

PROCESS_DATA_FROM_OUTPUT_RECORD_END 

return(status);

}
/*-----------------------------------------------------------------------------------------*/


int GPMMgetADCdata(
    unsigned short card,
    unsigned short signal,
    struct recDesc  *parm,
    unsigned short   sRecordType,
    unsigned short   sRecordPass,
    char *chanName,
    void *pVal
)
{
  unsigned long  lVal;
  unsigned short sVal;
  char *pPropertyName;
  short status=RETURN_OK;
  unsigned int   iX=0;
  unsigned int   iY=0;
  unsigned int   iZ=0;
  int   iValTmp=0;
  static unsigned int iAvgVal[8]={0,0,0,0,0,0,0,0};
  double dAvg[8]={0,0,0,0,0,0,0,0};
  double dAvg2=0;
  double dSigma=0;
  double dX_1=0;
  int    iSmpNr=0;
  int    iMaxChan=0;
  static int *uiChan[8]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
  /*struct timespec t0;
  struct timespec t1;
  ULONG  uT0=0;
  ULONG  uT1=0; */

  struct register_Node  *regNode=NULL;

  /* clock_gettime(CLOCK_REALTIME,&t0);
     uT0=tickGet(); */

  lVal=*((unsigned long *)pVal);   /* for ai ao record. lVal refers to the rval field */
  sVal=*((unsigned short*) lVal);  /* for mbbi mbbo */
  
  pPropertyName=strchr(chanName,':');

  if(sRecordPass==REC_ENTER){
    /* do the data processing when enetring the driver writ/read function for the specyfic record */
    PRINT_DEBUG("FUNCTION GPMMgetADCdata PASS on ENTER\n");
    if(sRecordType==REC_WF){
      PRINT_DEBUG("Record WF read\n");
      if(parm->lInArg1 > 1){ /* channels bigger than 1 */
	if(uiChan[(parm->lInArg1)-1]==NULL){
	  uiChan[(parm->lInArg1)-1]=(int *)pVal;
	  PRINT_DEBUG("WF channel %d initalised %p\n",(int)parm->lInArg1,uiChan[(parm->lInArg1)-1]);
	}
      }
      else{                 /* read the FiFO if the channel nr 1 selected ie. parm->lInArg1==1 */
	regNode=parm->pRegLocation;
	PRINT_DEBUG("----- WF location %p ------\n",regNode->pLocalAddr);
	iY=signal;
	iSmpNr= parm->uiBytesNo >> 2;
	iSmpNr++;
	iMaxChan=parm->lInArg2;
	PRINT_DEBUG("Max samples nr %d\n", iSmpNr-1);
	PRINT_DEBUG("Max chans nr %d\n",iMaxChan );
	uiChan[0]=(int *)pVal;
	PRINT_DEBUG("WF channel %d points to  %p\n",(int)parm->lInArg1,uiChan[(parm->lInArg1)-1]);
	

      }/* end of else parm->lInArg1 */
      status=RETURN_USER_FUNC_SKIP | RETURN_WRITE_SKIP;
    }
    else if(sRecordType==REC_AI){
      PRINT_DEBUG("AI FUNCTION PASS on ENTER\n");
      
      status=RETURN_USER_FUNC_SKIP | RETURN_WRITE_SKIP;
    }
    else
      status=RETURN_USER_FUNC_SKIP | RETURN_WRITE_SKIP;
  }
  else{ /* REC EXIT */
    PRINT_DEBUG("FUNCTION GPMMgetADCdata PASS on EXIT\n");
    status=RETURN_OK;
  }
  if(sRecordType==REC_WF) 
    PRINT_DEBUG("WF record\n");
  PRINT_DEBUG("FUNCTION GPMMgetADCdata PASS RETURN code 0x%X\n",status);
  return (status);

}
