/* this is the header file which contains the declarations for the 
   user function */

/* record types declaration */   

#define REC_BI      0
#define REC_BO      1
#define REC_MBBI    2
#define REC_MBBO    3
#define REC_MBBI_D  4
#define REC_MBBO_D  5
#define REC_AI      6
#define REC_AO      7
#define REC_STR_IN  8
#define REC_WF      9
#define REC_LONGIN  10  /* the same as  REC_AI */
#define REC_LONGOUT 11  /* the same as  REC_AO */

/* define two possibilites for the user function */
/* on Record  processing ENTER or EXIT           */

#define REC_EXIT    0
#define REC_ENTER   1

/* return values from the user function */

#define RETURN_OK                0x0000
#define REURN_ERROR              0x0001
#define RETURN_WRITE_SKIP        0x0100  
#define RETURN_READ_SKIP         0x0200
#define RETURN_USER_FUNC_SKIP    0x0400

#define PROCESS_DATA             0x0301
#define ENTER_FUNC               0x0401
#define ERROR_OCCURED            0x0001


/* macros which support the creation of the user function */
 
#define PROCESS_DATA_FROM_INPUT_RECORD_BEGIN      if(sRecordPass==REC_EXIT){
#define PROCESS_DATA_FROM_INPUT_RECORD_END        }
 
#define RETURN_FROM_INPUT_RECORD_OK               RETURN_OK
#define RETURN_FROM_INPUT_RECORD_ERROR            REURN_ERROR
                                                                                
#define PROCESS_DATA_FROM_OUTPUT_RECORD_BEGIN     if(sRecordPass==REC_ENTER){
#define PROCESS_DATA_FROM_OUTPUT_RECORD_END       }
                                                                                
#define RETURN_FROM_OUTPUT_RECORD_OK              RETURN_OK   | RETURN_USER_FUNC_SKIP
#define RETURN_FROM_OUTPUT_RECORD_ERROR           REURN_ERROR | RETURN_USER_FUNC_SKIP


/* An example of user define function declaration */

/* int userFunctionName(
    unsigned short card,
    unsigned short signal,
    struct recDesc *parm,
    unsigned short   sRecordType,
    unsigned short   sRecordPass, 
    char *chanName,
    void *pVal
);

 int userGPMMFunc1(
    unsigned short card,
    unsigned short signal,
    struct recDesc  *parm,
    unsigned short   sRecordType,
    unsigned short   sRecordPass,
    char *chanName,
    void *pVal
    );
*/


